;;; (op-plus1 3) -> 4
;;; (op-minus1 3) -> 2

(defun op-plus1 (x)
  "Inkrementacia cisla o jednotku"
  (+ 1 x))

(defun op-minus1 (x)
  "Dekrementacia cisla o jednotku"
  (- x 1))

;;; Sucet dvoch cisel s vyuzitim funkcii op-plus1 a op-minus1
;;; Uvazovat iba celociselne nezaporne scitance

;;; Uvazovany pripad:
;;;   (op-plus 3 5) -> 8
;;; Neuvazovane pripady:
;;;   (op-plus -3 5)
;;;   (op-plus 3.3 5)


;;; Pocitanie smerom dovnutra rekurzie (pri vnarani)
;;;  3 + 5
;;;  2 + 6
;;;  1 + 7
;;;  0 + 8

(defun op-plus (x y)
  (if (zerop x) 
      y 
      (op-plus (op-minus1 x) (op-plus1 y))))


;;; Pocitanie smerom von z rekurzie (pri vynarani)
;;;                     3 + 5
;;;   1 + (             2 + 5     )
;;;   1 + ( 1 + (       1 + 5   ) )
;;;   1 + ( 1 + ( 1 + ( 0 + 5 ) ) )

(defun op-plus (x y)
  (if (zerop x) 
      y 
      (op-plus1 (op-plus (op-minus1 x) y))))


;;; Pocitanie smerom dovnutra rekurzie s pomocnou premennou pre
;;; tvorbu vysledku vypoctu
;;;   3 + 2
;;;   3 + 2 + 0
;;;   2 + 2 + 1
;;;   1 + 2 + 2
;;;   0 + 2 + 3
;;;   2 + 0 + 3
;;;   1 + 0 + 4
;;;   0 + 0 + 5

;;; riesenie s pomocnou funkciou
(defun op-plus-aux (x y acc)
  (cond ((and (zerop x) (zerop y)) acc)
	((zerop x) (op-plus-aux y x acc))
	(t (op-plus-aux (op-minus1 x) y (op-plus1 acc)))))
(defun op-plus (x y)
  (op-plus-aux x y 0))

;;; riesenie s nepovinnym argumentom s default hodnotou
(defun op-plus (x y &optional (acc 0))
  (cond ((and (zerop x) (zerop y)) acc)
	((zerop x) (op-plus y x acc))
	(t (op-plus (op-minus1 x) y (op-plus1 acc)))))


;;; Zrychlenie vypoctu v pripade, ze hodnota prveho argumentu je vacsia 
;;; ako hodnota druheho
;;;
;;; Poz: rychlost vypoctu mozno merat pomocou: (time (op-plus 9999 1))

(defun op-plus-aux (x y)
  (if (zerop x) y (op-plus-aux (op-minus1 x) (op-plus1 y))))
(defun op-plus (x y)
  (if (< x y)
      (op-plus-aux x y)
    (op-plus-aux y x)))

(defun op-plus (x y)
  (labels ((plus (x y)
                 (if (zerop x) y (plus (op-minus1 x) (op-plus1 y)))))
    (if (< x y)
        (plus x y)
      (plus y x))))

;;; Uloha 1 
;;; Upravte funkciu pre sucet tak, aby sa dala pouzit pre:
;;;   a) zaporne scitance
;;;   b) kladne aj zaporne scitance

;;; Uloha 2
;;; Vytvorte funkciu pre pocitanie rozdielu dvoch cisel
